$f=shift; #unaligned
$g=shift; #aligned
 
open(IN,$f); $i=-1;
while(<IN>){
 chomp $_;
 if(substr($_,0,1) eq '>'){ $i++; $names[$i] = $_; }
 else { $seqs[$i] .= $_; }
}
close IN;
$total=$i+1;

open(IN,$g); $i=-1;
while(<IN>){
 chomp $_;
 if(substr($_,0,1) eq '>'){ $i++; $truenames[$i] = $_; }
 else { $trueseqs[$i] .= $_; }
}
close IN;

$aa = "ACDEFGHIKLMNPQRSTVWY";
srand;

for(my $i=0;$i<$total;$i++){

  $l = rand 500; $l = int($l) + 1;
  $str=""; for(my $j=0;$j<$l;$j++){
    $r = rand 20; $r = int($r);
    $str .= substr($aa,$r,1);
  }

  #print "appending $str\n";
  if(rand() < 0.25){ $leftextend[$i] = $str; }
  else { $leftextend[$i] = "";}

  $l = rand 500; $l = int($l) + 1;
  $str=""; for(my $j=0;$j<$l;$j++){
    $r = rand 20; $r = int($r);
    $str .= substr($aa,$r,1);
  }

  #print "appending $str\n"; 
  if(rand() < 0.25){ $rightextend[$i] = $str; }
  else { $rightextend[$i] = "";}
}

open(OUT,">$f.NCext");
for(my $i=0;$i<$total;$i++){
  printf OUT "%s\n%s%s%s\n", $names[$i],$leftextend[$i],$seqs[$i],$rightextend[$i];
}
close OUT; $maxl=0;$maxr=0;
for(my $i=0;$i<$total;$i++){
  if(length($leftextend[$i]) > $maxl){$maxl=length($leftextend[$i]);}
  if(length($rightextend[$i]) > $maxr){$maxr=length($rightextend[$i]);}
}
open(OUT,">$g.NCext");
for(my $i=0;$i<$total;$i++){
  while(length($leftextend[$i]) < $maxl) { $leftextend[$i] = "-".$leftextend[$i]; }
  while(length($rightextend[$i]) < $maxr) { $rightextend[$i] = $rightextend[$i]."-"; }
  printf OUT "%s\n%s%s%s\n", $truenames[$i],lc($leftextend[$i]),$trueseqs[$i],lc($rightextend[$i]);
}

