$f=shift; #unaligned
$g=shift; #aligned
 
open(IN,$f); $i=-1;
while(<IN>){
 chomp $_;
 if(substr($_,0,1) eq '>'){ $i++; $names[$i] = $_; }
 else { $seqs[$i] .= $_; }
}
close IN;
$total=$i+1;

open(IN,$g); $i=-1;
while(<IN>){
 chomp $_;
 if(substr($_,0,1) eq '>'){ $i++; $truenames[$i] = $_; }
 else { $trueseqs[$i] .= $_; }
}
close IN;

$aa = "ACDEFGHIKLMNPQRSTVWY";
srand;

##find sequence to insert
$rand = rand $total; $rand = int($rand);

$l = rand 1000; $l = int($l) + 1;
$str=""; for(my $j=0;$j<$l;$j++){
  $r = rand 20; $r = int($r);
  $str .= substr($aa,$r,1);
}

$len = length($seqs[$rand]); $pos = rand $len; while($pos < 1){ $pos = rand $len;} $pos=int($pos);
#print "inserting at position $pos of sequence $rand\n";
$newseq = substr($seqs[$rand],0,$pos).$str.substr($seqs[$rand],$pos);
$seqs[$rand]=$newseq;

$truepos=0; $count=0; $replacei=0;
$truelen = length($trueseqs[$rand]);
for(my $i=0;$i<$truelen;$i++){
  if(substr($trueseqs[$rand],$i,1) ne "-"){ $count++; }
  if($count == $pos) { $replacei=$i; $i=$truelen;}
}
$replacei++;

#print "inserting in true alignment at position $replacei\n";

$gapstr = "";
for(my $i=0; $i<length($str); $i++){ $gapstr .= "-"; }

for(my $i=0;$i<$total;$i++){
  if($i ne $rand){ 
    $trueseq = substr($trueseqs[$i],0,$replacei).$gapstr.substr($trueseqs[$i],$replacei);
    $trueseqs[$i]=$trueseq;
  }
  else {
    $trueseq = substr($trueseqs[$i],0,$replacei).lc($str).substr($trueseqs[$i],$replacei);
    $trueseqs[$i]=$trueseq;
  }
}

open(OUT,">$f.inslong");
for(my $i=0;$i<$total;$i++){
  printf OUT "%s\n%s\n", $names[$i],$seqs[$i];
}
close OUT;
open(OUT,">$g.inslong");
for(my $i=0;$i<$total;$i++){
  printf OUT "%s\n%s\n", $truenames[$i],$trueseqs[$i];
}

